Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.cpp	(revision 105030)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.cpp	(revision 105031)
@@ -247,5 +247,5 @@
 
     /** Defines the parent @a pTable reference. */
-    void setTable(UIShortcutConfigurationTable *pTable);
+    void setTable(UIShortcutConfigurationView *pTable);
 
     /** Loads a @a list of shortcuts to the model. */
@@ -290,5 +290,5 @@
 
     /** Holds the parent table reference. */
-    UIShortcutConfigurationTable *m_pTable;
+    UIShortcutConfigurationView *m_pTable;
 
     /** Holds current filter. */
@@ -306,5 +306,5 @@
 
 /** QITableView subclass representing shortcut configuration table. */
-class UIShortcutConfigurationTable : public QITableView
+class UIShortcutConfigurationView : public QITableView
 {
     Q_OBJECT;
@@ -315,7 +315,7 @@
       * @param  pModel         Brings the model this table is bound to.
       * @param  strObjectName  Brings the object name this table has, required for fast referencing. */
-    UIShortcutConfigurationTable(QWidget *pParent, UIShortcutConfigurationModel *pModel, const QString &strObjectName);
+    UIShortcutConfigurationView(QWidget *pParent, UIShortcutConfigurationModel *pModel, const QString &strObjectName);
     /** Destructs table. */
-    virtual ~UIShortcutConfigurationTable() RT_OVERRIDE;
+    virtual ~UIShortcutConfigurationView() RT_OVERRIDE;
 
 private slots:
@@ -347,5 +347,5 @@
 }
 
-void UIShortcutConfigurationModel::setTable(UIShortcutConfigurationTable *pTable)
+void UIShortcutConfigurationModel::setTable(UIShortcutConfigurationView *pTable)
 {
     m_pTable = pTable;
@@ -687,10 +687,10 @@
 
 /*********************************************************************************************************************************
-*   Class UIShortcutConfigurationTable implementation.                                                                           *
+*   Class UIShortcutConfigurationView implementation.                                                                            *
 *********************************************************************************************************************************/
 
-UIShortcutConfigurationTable::UIShortcutConfigurationTable(QWidget *pParent,
-                                                           UIShortcutConfigurationModel *pModel,
-                                                           const QString &strObjectName)
+UIShortcutConfigurationView::UIShortcutConfigurationView(QWidget *pParent,
+                                                         UIShortcutConfigurationModel *pModel,
+                                                         const QString &strObjectName)
     : QITableView(pParent)
     , m_pItemEditorFactory(0)
@@ -705,5 +705,5 @@
 }
 
-UIShortcutConfigurationTable::~UIShortcutConfigurationTable()
+UIShortcutConfigurationView::~UIShortcutConfigurationView()
 {
     /* Cleanup all: */
@@ -711,5 +711,5 @@
 }
 
-void UIShortcutConfigurationTable::sltHandleShortcutsLoaded()
+void UIShortcutConfigurationView::sltHandleShortcutsLoaded()
 {
     /* Resize columns to feat contents: */
@@ -721,5 +721,5 @@
 }
 
-void UIShortcutConfigurationTable::prepare()
+void UIShortcutConfigurationView::prepare()
 {
     /* Configure self: */
@@ -741,5 +741,5 @@
     if (pHotKeyTableModel)
         connect(pHotKeyTableModel, &UIShortcutConfigurationModel::sigShortcutsLoaded,
-                this, &UIShortcutConfigurationTable::sltHandleShortcutsLoaded);
+                this, &UIShortcutConfigurationView::sltHandleShortcutsLoaded);
 
     /* Check if we do have proper item delegate: */
@@ -770,5 +770,5 @@
 }
 
-void UIShortcutConfigurationTable::cleanup()
+void UIShortcutConfigurationView::cleanup()
 {
     /* Cleanup item editor factory: */
@@ -893,5 +893,5 @@
 
             /* Prepare Manager UI table: */
-            m_pTableManager = new UIShortcutConfigurationTable(pTabManager, m_pModelManager, "m_pTableManager");
+            m_pTableManager = new UIShortcutConfigurationView(pTabManager, m_pModelManager, "m_pTableManager");
             if (m_pTableManager)
             {
@@ -930,5 +930,5 @@
 
             /* Create Runtime UI table: */
-            m_pTableRuntime = new UIShortcutConfigurationTable(pTabMachine, m_pModelRuntime, "m_pTableRuntime");
+            m_pTableRuntime = new UIShortcutConfigurationView(pTabMachine, m_pModelRuntime, "m_pTableRuntime");
             if (m_pTableRuntime)
             {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.h	(revision 105030)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/editors/UIShortcutConfigurationEditor.h	(revision 105031)
@@ -39,5 +39,5 @@
 class QTabWidget;
 class UIShortcutConfigurationModel;
-class UIShortcutConfigurationTable;
+class UIShortcutConfigurationView;
 
 /** Shortcut search functor template. */
@@ -213,9 +213,9 @@
     QLineEdit                    *m_pEditorFilterManager;
     /** Holds the Manager UI shortcuts table instance. */
-    UIShortcutConfigurationTable *m_pTableManager;
+    UIShortcutConfigurationView  *m_pTableManager;
     /** Holds the Runtime UI shortcuts filter instance. */
     QLineEdit                    *m_pEditorFilterRuntime;
     /** Holds the Runtime UI shortcuts table instance. */
-    UIShortcutConfigurationTable *m_pTableRuntime;
+    UIShortcutConfigurationView  *m_pTableRuntime;
 };
 